//+------------------------------------------------------------------+
//|                                            MomentumUniversal.mq4 |
//|                                       Copyright 2015, Marketeer. |
//|                          https://www.mql5.com/en/users/marketeer |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Marketeer"
#property link      "https://www.mql5.com/en/users/marketeer"
#property version   "1.00"
#property strict
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_plots   1

#property indicator_label1  "Momentum"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrRed
#property indicator_style1  STYLE_SOLID
#property indicator_width1  2

extern int MomentumPeriod = 7;

// indicator buffers
double MomentumBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
{
  SetIndexBuffer(0, MomentumBuffer);
  
  return(INIT_SUCCEEDED);
}
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total, const int prev_calculated, const int begin, const double& price[])
{
  for(int i = rates_total - 1; i >= prev_calculated; i--)
  {
    if(i - MomentumPeriod >= 0)
    {
      MomentumBuffer[i] = price[i] - price[i - MomentumPeriod];
    }
    else
    {
      MomentumBuffer[i] = EMPTY_VALUE;
    }
  }
  return(rates_total);
}
//+------------------------------------------------------------------+
